/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package queue;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.ejb.Stateless;
import javax.jms.*;
import javax.naming.*;
/**
 *
 * @author prashanth
 */
@WebService()
@Stateless()
public class EnqueueRequestWebService {

    /**
     * Web service operation
     */
    @WebMethod(operationName = "Enqueue")
    public String Enqueue(@WebParam(name = "title")
    String title, @WebParam(name = "description")
    String description, @WebParam(name = "htmlcode")
    String htmlcode, @WebParam(name = "rules")
    String rules) {
         String msg="Title:"+title+"\n" +
                "Description:"+ description + "\n" +
                "Htmlcode:" + htmlcode +"\n" +
                "Rules:" + rules + "\n";
        
        javax.jms.Connection  connection=null;        
        try
        {
            Context ctx = new InitialContext();
            ConnectionFactory     connectionFactory = (ConnectionFactory)ctx.lookup("jms/tConnectionFactory");
            Queue     queue = (Queue)ctx.lookup("jms/tQueue");
            connection = connectionFactory.createConnection();
            javax.jms.Session session1 = connection.createSession(false,Session.AUTO_ACKNOWLEDGE);
            MessageProducer messageProducer = session1.createProducer(queue);
            TextMessage message = session1.createTextMessage();
            message.setText(msg);
            
            messageProducer.send(message);
            
            System.out.println( "Enqueue:" + message.getText() + " to " + queue.getQueueName());       
            
            connection.close();
            
        } catch(Exception ex)
        {
            ex.printStackTrace();
            try
            {
                connection.close();
            }
            catch(Exception e)
            {
            
            }
            return "failure";
        }
        return "success";
       
    }

}
