
package org.netbeans.xml.schema.portaldataschema;

import javax.xml.bind.JAXBElement;
import javax.xml.bind.annotation.XmlElementDecl;
import javax.xml.bind.annotation.XmlRegistry;
import javax.xml.namespace.QName;


/**
 * This object contains factory methods for each 
 * Java content interface and Java element interface 
 * generated in the org.netbeans.xml.schema.portaldataschema package. 
 * <p>An ObjectFactory allows you to programatically 
 * construct new instances of the Java representation 
 * for XML content. The Java representation of XML 
 * content can consist of schema derived interfaces 
 * and classes representing the binding of schema 
 * type definitions, element declarations and model 
 * groups.  Factory methods for each of these are 
 * provided in this class.
 * 
 */
@XmlRegistry
public class ObjectFactory {

    private final static QName _SubscribeResponse_QNAME = new QName("http://xml.netbeans.org/schema/PortalDataSchema", "subscribeResponse");
    private final static QName _SubscribeRequestElement_QNAME = new QName("http://xml.netbeans.org/schema/PortalDataSchema", "subscribeRequestElement");

    /**
     * Create a new ObjectFactory that can be used to create new instances of schema derived classes for package: org.netbeans.xml.schema.portaldataschema
     * 
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link SubscribeRequest }
     * 
     */
    public SubscribeRequest createSubscribeRequest() {
        return new SubscribeRequest();
    }

    /**
     * Create an instance of {@link Response }
     * 
     */
    public Response createResponse() {
        return new Response();
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Response }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://xml.netbeans.org/schema/PortalDataSchema", name = "subscribeResponse")
    public JAXBElement<Response> createSubscribeResponse(Response value) {
        return new JAXBElement<Response>(_SubscribeResponse_QNAME, Response.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SubscribeRequest }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://xml.netbeans.org/schema/PortalDataSchema", name = "subscribeRequestElement")
    public JAXBElement<SubscribeRequest> createSubscribeRequestElement(SubscribeRequest value) {
        return new JAXBElement<SubscribeRequest>(_SubscribeRequestElement_QNAME, SubscribeRequest.class, null, value);
    }

}
