/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gamedetailsmdb;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.MessageDrivenContext;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;

/**
 *
 * @author prashanth
 */
@MessageDriven(mappedName = "jms/tQueue", activationConfig =  {
        @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
        @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue")
    })
public class GameDetailsMDBBean implements MessageListener {
    
    private MessageDrivenContext mdc;
    public GameDetailsMDBBean() {
    }

    public void onMessage(Message message) 
    {
        TextMessage msg = null;
        try 
        {
            if (message instanceof TextMessage) 
            {
                msg = (TextMessage) message;
                System.out.println("A Message received in TMDB: " + msg.getText());
            }
            else 
            {
                System.out.println("Message of wrong type: " +  message.getClass().getName());
                
            }
        } 
        catch (JMSException e) 
        {
            e.printStackTrace();
            mdc.setRollbackOnly();
        }
        catch (Throwable te) 
        {
            te.printStackTrace();
        }
    }
    
}
